place 0h

; Utilizao dos registos:
; R1  ltimo valor da srie at um dado momento
; R2  penltimo valor da srie at um dado momento
; R3  base da zona de memria onde os elementos so escritos
; R4  contador de elementos da srie (serve tambm como ndice nos acessos 
;       memria)
base	EQU	1000H		; endereo onde comear a colocar a srie

incio:	MOV	R3, base	; inicializa apontador para o primeiro elemento
	MOV	R2, 1		; inicializa primeiro elemento da srie
	MOV	R1, 1		; inicializa segundo elemento da srie
	MOV	[R3], R2	; armazena primeiro elemento da srie
	MOV	[R3 + 2], R2	; armazena primeiro elemento da srie
	MOV	R4, 4		; j foram armazenados 2 elementos
maisUm:	ADD	R2, R1		; soma os dois ltimos elementos
	JV	fim		; se houve excesso, a srie tem de acabar aqui
	MOV	[R3 + R4], R2	; armazena mais este elemento da srie
	ADD	R4, 2		; contabiliza mais este elemento
	SWAP	R1, R2		; troca os papis de R1 e R2, para que R1 volte a 
				; ser o ltimo valor da srie e R2 o penltimo
	JMP	maisUm		; ainda h mais elementos para gerar
fim:	JMP	fim		; acabou. Na memria esto todos os elementos 
				; gerados, e R4 indica quantos so 
